#include <OneWire.h>

OneWire ds(10);  // an pin 10



uint8_t wrbuf[256]; //Buffer of bytes receive from 1-Wire slave
//Buffer of receive from Serial
union {
  uint8_t bytes[128+3];
  struct {
    uint8_t com; //Command
    uint8_t sbc; //number of bytes send to slave
    uint8_t rbc; //number of bytes get from slave
    uint8_t bufs[128]; //sendbuf
  };
} srbuf;


#define ST_SLEEP 0
#define ST_RECEIVE_HEAD 1 
#define ST_RECEIVE_DATA 2
#define ST_SEND_DATA 3
uint8_t state=ST_SLEEP;

#define COM_IDENTIFER 1
#define COM_RESET 2
#define COM_SEARCH_INIT 3
#define COM_SEARCH_NEXT 4
#define COM_BLOCK 5
#define COM_SBYTE 6
#define COM_RBYTE 7
#define COM_SBIT 8
#define COM_RBIT 9

    
uint8_t rc=0,sc=0;
 uint8_t r;

void loop(void) {
  while(1) {
      if (Serial.available()) {
        r = Serial.read();
        if (state<=ST_RECEIVE_DATA) {
            if (state==ST_SLEEP) { //Begin communikation
               state=ST_RECEIVE_HEAD; rc=0;
            }
            srbuf.bytes[rc]=r;
            rc++;
            if (rc==3) { //header empfangen
                state=ST_RECEIVE_DATA;sc=0;
            } else
            if (state==ST_RECEIVE_DATA) {
               if ((rc)>=(srbuf.sbc+3)) {
                 state=ST_SEND_DATA;
               }
            }
        }
      }
      byte addr[8];
      if (state==ST_RECEIVE_DATA) {
      switch (srbuf.com) {
        case COM_IDENTIFER:
          Serial.write(0x81); 
          Serial.write(0x22);
          Serial.write(0x22);
          Serial.flush();
          state=ST_SLEEP;
          break;
        case COM_RESET:
          if (ds.reset()) {
             Serial.write(0x01);        
          } else
             Serial.write(0x00);
          Serial.flush();
          state=ST_SLEEP;
          break;
        case COM_SEARCH_INIT:
          ds.reset_search();
           if ( !ds.search(addr)) {
              for(int i=0;i<8;i++) Serial.write(0x00);
           } else {
              for(int i=0;i<8;i++) Serial.write(addr[i]);
           }
           Serial.flush();
             state=ST_SLEEP;
            break;
        case COM_SEARCH_NEXT:
           if ( !ds.search(addr)) {
              for(int i=0;i<8;i++) Serial.write(0x00);
           } else {
              for(int i=0;i<8;i++) Serial.write(addr[i]);
           }
           Serial.flush();
             state=ST_SLEEP;
            break;
        case COM_BLOCK:
          if (rc>sc+3) {
            ds.write(srbuf.bufs[sc],0);
        //    Serial.write(srbuf.bufs[sc]);  
            sc++;
           }
           break;
    case COM_SBYTE:
  /*          if (rc==4) {
              ds.write(srbuf.bufs[0],0);
              Serial.write(1);
              Serial.write(srbuf.bufs[0]);
              Serial.write(1);
              Serial.write(1);
              Serial.write(1);
              Serial.write(1);
              Serial.write(1);
              Serial.write(1);
              Serial.write(1);
              Serial.write(1);
              Serial.write(1);
              Serial.write(1);
              
              Serial.flush();
              state=ST_SLEEP;
            }*/
            break;
      case COM_RBYTE:
              
              Serial.write(ds.read());
               Serial.flush();
              state=ST_SLEEP;
                   break;
       default:
              state=ST_SLEEP;
                   break;
      
   }
    
  }
  if ( state==ST_SEND_DATA) {
    //Serial.write("Hallo");
   switch (srbuf.com) {
    case COM_SBYTE:
              ds.write(srbuf.bufs[0],0);
              Serial.write(srbuf.bufs[0]);
              
              Serial.flush();
              state=ST_SLEEP;
            break;
          
    case COM_BLOCK:        
        /*while (rc>sc+3) {
            ds.write(srbuf.bufs[sc],0);
            Serial.write(srbuf.bufs[sc]);  
              sc++;
         }*/
      /*   for(uint8_t i=0;i<srbuf.sbc;i++) {
            ds.write(srbuf.bufs[i],0);
         }*/
         if (rc>sc+3) {
            ds.write(srbuf.bufs[sc],0);
        //    Serial.write(srbuf.bufs[sc]);  
            sc++;
           }
         for(uint8_t i=0;i<srbuf.rbc;i++) {
          Serial.write(ds.read());
        }
          state=ST_SLEEP;
          break;        
  }
  }
  }
}
     
void setup(void) {
// inputs/outputs initialisieren
// seriellen port starten
      Serial.begin(9600);
      
}
  


